#!/usr/bin/env python
# -*- coding: utf-8 -*-

# # Capture standard output and error
# 
# Python standard output is different from C standard output. When Python embeds a C library which prints something on the standard output, it is difficult to catch it from Python.

# See also [print and cleaning](https://docs.python.org/3/c-api/exceptions.html#printing-and-clearing) and [PySys_WriteStdout](https://docs.python.org/3/c-api/sys.html#PySys_WriteStdout).

# In[1]:


from jyquickhelper import add_notebook_menu
add_notebook_menu()


# In[2]:


from cpyquickhelper.io import capture_output


# ## Python Capture with Python print

# In[3]:


def python_print():
    print("one line")
    print("two lines")
    
res, out, err = capture_output(python_print, lang="py")
type(out), out


# ## C Capture with C print

# In[4]:


from cpyquickhelper.io.stdchelper import cprint

def c_print():
    cprint("one line")
    cprint("two lines")
    
res, out, err = capture_output(c_print, lang="c")
type(out), out


# ## Python capture with C print

# In[5]:


res, out, err = capture_output(c_print, lang="py")
type(out), out


# ## C capture with Python print
# 
# On Windows, the behavior of this code is different in a standalone program probably because jupyter catches the output on his side too.

# In[6]:


res, out, err = capture_output(python_print, lang="c")
type(out), out


# In[7]: